<template>
    <v-chart ref="echart" :options="chart_options" autoresize></v-chart>
</template>

<script>
export default {
    name: "LineChart",
    props: {
        chart_data: Array,
        is_currency: Boolean,
        range: String,
        options: Object
    },
    watch: {
        chart_data(data){
            if(Array.isArray(this.chart_data) && this.chart_data.length){
                this.setChartData(this.chart_data);
            }
        },
        is_currency(is_currency){
            if(is_currency){
                this.chart_options.tooltip.formatter = (params) => {
                    return '$' + Number.parseFloat(params.value[1]).toFixed(2);
                }
                this.chart_options.yAxis.axisLabel.formatter = (value) => {
                    return '$' + Number.parseInt(value);
                }
            }else{
                this.chart_options.tooltip.formatter = (params) => {
                    return params.value[1];
                }
                this.chart_options.yAxis.axisLabel.formatter = (value) => {
                    return value;
                }
            }
        },
        range(range){
            if(range === 'months'){
                this.chart_options.xAxis.axisLabel.formatter = (value) => {
                    return this.$date(value).format('MM');
                }
            }else{
                this.chart_options.xAxis.axisLabel.formatter = (value) => {
                    return this.$date(value).format('DD.MM');
                }
            }
        },
        options(options){
            this.chart_options = _.merge(this.chart_options, options);
        }
    },
    data(){
        return {
            chart_options: {
                grid: {
                    top: '10%',
                    left: 0,
                    right: '10%',
                    width: 'auto',
                    height: '90%',
                    containLabel: true,
                },
                tooltip: {
                    show: true,
                    trigger: 'item',
                    enterable: true,
                    backgroundColor: '#ffffff',
                    textStyle: {
                        color: '#346be8',
                        fontFamily: 'Geometria',
                        fontSize: 14,
                        lineHeight: 20,
                        fontWeight: 'bold',
                    },
                    padding: [5, 8],
                    extraCssText: 'border-radius: 5px;filter: drop-shadow(0px 5px 5px rgba(120,120,120,0.25));',
                    formatter: function (params){
                        console.log(params);
                        return '$' + Number.parseFloat(params.value[1]).toFixed(2);
                    },
                    position: 'top',
                    axisPointer: {
                        type: 'line',
                        snap: false,
                        lineStyle: {
                            color: '#eeecf1',
                            width: 2,
                        }
                    },
                },
                xAxis: {
                    type: 'category',
                    axisLine: {
                        show: false,
                    },
                    axisTick: {
                        show: false,
                    },
                    axisLabel: {
                        color: '#b5b5b5',
                        interval: 0,
                        fontFamily: 'Geometria',
                        fontSize: 13,
                        lineHeight: 20,
                        formatter: (value) => {
                            return this.$date(value).format('DD.MM');
                        }
                    },
                    splitLine: {
                        show: true,
                        color: '#dedede',
                        width: 1,
                    },
                    boundaryGap: false,
                },
                yAxis: {
                    type: 'value',
                    axisLine: {
                        show: false,
                    },
                    axisTick: {
                        show: false,
                    },
                    splitLine: {
                        show: false,
                    },
                    axisLabel: {
                        formatter: (value) => {
                            return Number.parseInt(value) + '$';
                        },
                        color: '#b5b5b5',
                        fontFamily: 'Geometria',
                        fontSize: 13,
                        lineHeight: 20,
                    }
                },
                series: [
                    {
                        name: 'chart',
                        type: 'line',
                        smooth: true,
                        connectNulls: true,
                        lineStyle: {
                            color: {
                                type: 'linear',
                                x: 0,
                                y: 0.5,
                                x2: 1,
                                y2: 0.5,
                                colorStops: [{
                                    offset: 0, color: 'rgb(84, 149, 255)' // color at 100% position
                                }, {
                                    offset: 1, color: 'rgb(134, 57, 229)' // color at 0% position
                                }],
                                global: false // false by default
                            },
                            width: 5,
                        },
                        itemStyle: {
                            borderColor: '#fff',
                            borderWidth: 2,
                        },
                        emphasis: {
                            itemStyle: {
                                borderColor: '#fff',
                                borderWidth: 8,
                                shadowColor: 'rgba(128,69,233,0.25)',
                                shadowBlur: 5
                            },
                        },
                        showSymbol: true,
                        shadowColor: 'rgba(41, 46, 56, 0.5)',
                        shadowBlur: 10,
                        data: [
                            {
                                value: 1,
                                name: '01.01',
                            },
                            {
                                value: 2,
                                name: '02.01',
                            },
                        ]
                    },
                ]
            }
        }
    },
    methods: {
        setChartData(data){
            this.chart_options.series[0].data = data;
        }
    },
    mounted() {
        if(Array.isArray(this.chart_data) && this.chart_data.length){
            this.setChartData(this.chart_data);
        }
        if(this.options){
            this.chart_options = _.merge(this.chart_options, this.options);
        }
    }
}
</script>

<style scoped>
.echarts {
    width: 100%;
    height: 280px;
    margin-bottom: 10px;
}
</style>
